aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorAndrew Clemons <andrew.clemons@gmail.com>2024-10-25 09:49:54 +0700
committerWilly Sudiarto Raharjo <willysr@slackbuilds.org>2024-10-25 10:34:00 +0700
commit014b4fcf4835512b339260a3fa8d3482175935ca (patch)
treef9eec4404afa617f4776c7339b63cbfe205ba768
parent5565bb2d714f57aea850ed9fd9de9d673fc54ad1 (diff)
development/pnpm: Added (efficient package manager).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--development/pnpm/README1
-rw-r--r--development/pnpm/pnpm.SlackBuild150
-rw-r--r--development/pnpm/pnpm.info10
-rw-r--r--development/pnpm/slack-desc19
4 files changed, 180 insertions, 0 deletions
diff --git a/development/pnpm/README b/development/pnpm/README
new file mode 100644
index 000000000000..dc497515d8ff
--- /dev/null
+++ b/development/pnpm/README
@@ -0,0 +1 @@
+pnpm - Fast, disk space efficient package manager
diff --git a/development/pnpm/pnpm.SlackBuild b/development/pnpm/pnpm.SlackBuild
new file mode 100644
index 000000000000..8e1241804a4f
--- /dev/null
+++ b/development/pnpm/pnpm.SlackBuild
@@ -0,0 +1,150 @@
+#!/bin/bash
+
+# Slackware build script for pnpm
+
+# Copyright 2024 Andrew Clemons, Tokyo Japan
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=pnpm
+VERSION=${VERSION:-9.12.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ LIBDIRSUFFIX="64"
+else
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+mkdir $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tgz -C $PRGNAM-$VERSION --strip-components 1
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# disable self-update / update checking
+cat << EOF | patch -p1
+diff -Naur package.bak/dist/pnpm.cjs package/dist/pnpm.cjs
+--- package.bak/dist/pnpm.cjs 1985-10-26 17:15:00.000000000 +0900
++++ package/dist/pnpm.cjs 2024-10-21 08:25:39.316000954 +0900
+@@ -116063,6 +116063,7 @@
+ var write_json_file_1 = __importDefault2(require_write_json_file());
+ var UPDATE_CHECK_FREQUENCY = 24 * 60 * 60 * 1e3;
+ async function checkForUpdates(config) {
++ return; // disabled
+ const stateFile = path_1.default.join(config.stateDir, "pnpm-state.json");
+ let state;
+ try {
+@@ -220075,6 +220076,7 @@
+ });
+ }
+ async function handler(opts) {
++ throw new error_1.PnpmError("CANT_SELF_UPDATE_IN_PKGTOOLS", "You should update pnpm with the slackbuild");
+ if ((0, cli_meta_1.isExecutedByCorepack)()) {
+ throw new error_1.PnpmError("CANT_SELF_UPDATE_IN_COREPACK", "You should update pnpm with corepack");
+ }
+EOF
+
+# don't need node-gyp
+rm -rf dist/node-gyp-bin/ dist/node_modules/node-gyp/
+
+# remove files for other platforms
+rm -rf dist/vendor/*.exe
+rm -rf dist/reflink*darwin*
+rm -rf dist/reflink*win32*
+find . -type f \( -name '*.cmd' -o -name '*.bat' -o -name '*.ps1' \) -delete
+
+# remove sourcemaps, not needed
+find . -type f -name '*.map' -delete
+
+# remove hidden files and directories, not needed
+find dist/node_modules -type f -name '.*' -delete
+find dist/node_modules -type d -name '.*' -print0 | xargs -0 -n1 rm -rvf
+
+# make sure we use the system node
+sed -i 's,/usr/bin/env node,/usr/bin/node,g' bin/*
+
+mkdir -p $PKG/usr/share/bash-completion/completions/
+install -Dm644 dist/templates/completion.bash $PKG/usr/share/bash-completion/completions/$PRGNAM
+
+mkdir -p $PKG/usr/share/zsh/site-functions/
+install -Dm644 dist/templates/completion.zsh $PKG/usr/share/zsh/site-functions/_$PRGNAM
+
+rm -rf dist/templates
+
+install -Dm644 package.json -t $PKG/usr/lib$LIBDIRSUFFIX/node_modules/$PRGNAM
+install -Dm755 bin/pnpm.cjs bin/pnpx.cjs -t $PKG/usr/lib$LIBDIRSUFFIX/node_modules/$PRGNAM/bin
+
+cp -r dist $PKG/usr/lib$LIBDIRSUFFIX/node_modules/$PRGNAM/dist
+
+mkdir -p $PKG/usr/bin
+ln -sf ../lib$LIBDIRSUFFIX/node_modules/$PRGNAM/bin/pnpm.cjs $PKG/usr/bin/pnpm
+ln -sf ../lib$LIBDIRSUFFIX/node_modules/$PRGNAM/bin/pnpx.cjs $PKG/usr/bin/pnpx
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ LICENSE README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/pnpm/pnpm.info b/development/pnpm/pnpm.info
new file mode 100644
index 000000000000..28b38e0c67f7
--- /dev/null
+++ b/development/pnpm/pnpm.info
@@ -0,0 +1,10 @@
+PRGNAM="pnpm"
+VERSION="9.12.2"
+HOMEPAGE="https://pnpm.io"
+DOWNLOAD="https://registry.npmjs.org/pnpm/-/pnpm-9.12.2.tgz"
+MD5SUM="6786cc3a33869cfaac61c81c9d67b0da"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="nodejs"
+MAINTAINER="Andrew Clemons"
+EMAIL="andrew.clemons@gmail.com"
diff --git a/development/pnpm/slack-desc b/development/pnpm/slack-desc
new file mode 100644
index 000000000000..09d6756c993b
--- /dev/null
+++ b/development/pnpm/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+pnpm: pnpm (Fast, disk space efficient package manager)
+pnpm:
+pnpm: https://pnpm.io/
+pnpm:
+pnpm:
+pnpm:
+pnpm:
+pnpm:
+pnpm:
+pnpm:
+pnpm: